MyGUI: MyGUI::FactoryManager Class Reference

MyGUI 3.2.2

Public Types | Public Member Functions
MyGUI::FactoryManager Class Reference

`#include <MyGUI_FactoryManager.h>`

Inheritance diagram for MyGUI::FactoryManager:
[legend]

## Public Types
typedef delegates::CDelegate1< IObject *& > | Delegate
Public Types inherited from MyGUI::Singleton< FactoryManager >
typedef Singleton< FactoryManager > | Base

## Public Member Functions
| FactoryManager ()
void | initialise ()
void | shutdown ()
void | registerFactory (const std::string &_category, const std::string &_type, Delegate::IDelegate *_delegate)
void | unregisterFactory (const std::string &_category, const std::string &_type)
void | unregisterFactory (const std::string &_category)
bool | isFactoryExist (const std::string &_category, const std::string &_type)
template<typename Type >
void | registerFactory (const std::string &_category)
template<typename Type >
void | registerFactory (const std::string &_category, const std::string &_type)
template<typename Type >
void | unregisterFactory (const std::string &_category)
IObject * | createObject (const std::string &_category, const std::string &_type)
template<typename Type >
Type * | createObject (const std::string &_category)
void | destroyObject (IObject *_object)
Public Member Functions inherited from MyGUI::Singleton< FactoryManager >
| Singleton ()
virtual | ~Singleton ()

## Additional Inherited Members
Static Public Member Functions inherited from MyGUI::Singleton< FactoryManager >
static FactoryManager & | getInstance ()
static FactoryManager * | getInstancePtr ()
static const char * | getClassTypeName ()

## Detailed Description

Definition at line 18 of file MyGUI_FactoryManager.h.

## Member Typedef Documentation

## ◆ Delegate

typedef delegates::CDelegate1<IObject*&> MyGUI::FactoryManager::Delegate

Definition at line 27 of file MyGUI_FactoryManager.h.

## Constructor & Destructor Documentation

## ◆ FactoryManager()

MyGUI::FactoryManager::FactoryManager | ( |  | ) |

Definition at line 17 of file MyGUI_FactoryManager.cpp.

## Member Function Documentation

## ◆ createObject() [1/2]

template<typename Type >

Type* MyGUI::FactoryManager::createObject | ( | const std::string & | _category | ) |
| inline

Create object with given _category and _type. Return nullptr if there's no registered factory.

Definition at line 63 of file MyGUI_FactoryManager.h.

## ◆ createObject() [2/2]

IObject * MyGUI::FactoryManager::createObject | ( | const std::string & | _category,
|  | const std::string & | _type
| ) |  |

Create object with given _category and _type. Return nullptr if there's no registered factory.

Definition at line 72 of file MyGUI_FactoryManager.cpp.

## ◆ destroyObject()

void MyGUI::FactoryManager::destroyObject | ( | IObject * | _object | ) |

Destroy object

Definition at line 96 of file MyGUI_FactoryManager.cpp.

## ◆ initialise()

void MyGUI::FactoryManager::initialise | ( |  | ) |

Definition at line 22 of file MyGUI_FactoryManager.cpp.

## ◆ isFactoryExist()

bool MyGUI::FactoryManager::isFactoryExist | ( | const std::string & | _category,
|  | const std::string & | _type
| ) |  |

Is factory for specified _category and _type exist.

Definition at line 118 of file MyGUI_FactoryManager.cpp.

## ◆ registerFactory() [1/3]

template<typename Type >

void MyGUI::FactoryManager::registerFactory | ( | const std::string & | _category | ) |
| inline

Register factory for specified _category.

Definition at line 40 of file MyGUI_FactoryManager.h.

## ◆ registerFactory() [2/3]

template<typename Type >

void MyGUI::FactoryManager::registerFactory | ( | const std::string & | _category,
|  | const std::string & | _type
| ) |  |
| inline

Register factory for specified _category and _type.

Definition at line 47 of file MyGUI_FactoryManager.h.

## ◆ registerFactory() [3/3]

void MyGUI::FactoryManager::registerFactory | ( | const std::string & | _category,
|  | const std::string & | _type,
|  | Delegate::IDelegate * | _delegate
| ) |  |

Register delegate function that creates object for specified _category and _type.

Definition at line 40 of file MyGUI_FactoryManager.cpp.

## ◆ shutdown()

void MyGUI::FactoryManager::shutdown | ( |  | ) |

Definition at line 31 of file MyGUI_FactoryManager.cpp.

## ◆ unregisterFactory() [1/3]

void MyGUI::FactoryManager::unregisterFactory | ( | const std::string & | _category | ) |

Unregister all delegate functions that creates object for specified _category.

Definition at line 62 of file MyGUI_FactoryManager.cpp.

## ◆ unregisterFactory() [2/3]

template<typename Type >

void MyGUI::FactoryManager::unregisterFactory | ( | const std::string & | _category | ) |
| inline

Unegister factory for specified _category.

Definition at line 54 of file MyGUI_FactoryManager.h.

## ◆ unregisterFactory() [3/3]

void MyGUI::FactoryManager::unregisterFactory | ( | const std::string & | _category,
|  | const std::string & | _type
| ) |  |

Unregister delegate function that creates object for specified _category and _type.

Definition at line 46 of file MyGUI_FactoryManager.cpp.

The documentation for this class was generated from the following files:

- MyGUI_FactoryManager.h
- MyGUI_FactoryManager.cpp